OnlineStore.Mvc.Web/Controllers/BusketController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using OnlineStore.Core.Contracts;
using OnlineStore.Core.Models;

namespace OnlineStore.Mvc.Web.Controllers
{
    public class BusketController : Controller
    {
        public IBusketManager BusketManager { get; set; }
        public IOrderManager OrderManager { get; set; }
        public IRepository<Customer> Customers { get; set; }

        public BusketController(IBusketManager busketManager, IOrderManager orderManager, IRepository<Customer> Customers)
        {
            this.BusketManager = busketManager;
            this.OrderManager = orderManager;
            this.Customers = Customers;
        }

        public ActionResult Index()
        {
            var busketItems = BusketManager.GetBusketItems(this.HttpContext);
            return View(busketItems);
        }

        public ActionResult AddToBusket(string id)
        {
            BusketManager.AddBusket(this.HttpContext, id);
            return RedirectToAction("Index");
        }

        public ActionResult RemoveFromBusket(string id)
        {
            BusketManager.RemoveBusket(this.HttpContext, id);
            return RedirectToAction("Index");
        }

        public PartialViewResult BusketSummary()
        {
            var busketSummary = BusketManager.GetBusketSummary(this.HttpContext);
            return PartialView(busketSummary);
        }

        [Authorize]
        public ActionResult CheckOut()
        {
            Customer customer = Customers.Collection().FirstOrDefault(c => c.Email == User.Identity.Name);

            if (customer != null)
            {
                Order order = new Order()
                {
                    Email = customer.Email,
                    City = customer.City,
                    FirstName = customer.FirstName,
                    LastName = customer.LastName,
                    State = customer.State,
                    ZipCode = customer.ZipCode
                };
                return View(order);
            }
            else
            {
                return RedirectToAction("Error");
            }
        }
        [HttpPost]
        public ActionResult CheckOut(Order order)
        {
            var busket = BusketManager.GetBusketItems(this.HttpContext);
            order.OrderStatus = "Order Created";
            order.Email = User.Identity.Name;
            //process payment
            order.OrderStatus = "Payment Processed";
            OrderManager.CreateOrder(order, busket);
            BusketManager.ClearBusket(this.HttpContext);
            return RedirectToAction("ThankYou", new { OrderId = order.Id });
        }

        public ActionResult ThankYou(string OrderId)
        {
            ViewBag.Orderid = OrderId;
            return View();
        }

    }
}

OnlineStore.Mvc.Web/Controllers/HomeController.cs
using OnlineStore.Core.Contracts;
using OnlineStore.Core.Models;
using OnlineStore.Core.ViewModels;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;

namespace OnlineStore.Mvc.Web.Controllers
{
    [RequireHttps]
    public class HomeController : Controller
    {
        IRepository<Product> context;
        IRepository<ProductCategory> productCategories;

        public HomeController(IRepository<Product> productContext, IRepository<ProductCategory> productCategoryContext)
        {
            context = productContext;
            productCategories = productCategoryContext;
        }
        public ActionResult Index(string Category = null)
        {
            List<Product> products;
            List<ProductCategory> categories = productCategories.Collection().ToList();
            if(Category == null)
            {
                products = context.Collection().ToList();
            }
            else
            {
                products = context.Collection().Where(x => x.Category == Category).ToList();
            }

            ProductListView productList = new ProductListView
            {
                Products = products,
                ProductCategories = categories
            };

            return View(productList);
        }
        public ActionResult Details(string id)
        {
            Product product = context.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            else
            {
                return View(product);
            }
            
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}

OnlineStore.Mvc.Web/Views/Home/About.cshtml
@{
    ViewBag.Title = "About";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<p>Use this area to provide additional information.</p>

OnlineStore.Mvc.Web/Views/Home/Contact.cshtml
@{
    ViewBag.Title = "Contact";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<address>
    One Microsoft Way<br />
    Redmond, WA 98052-6399<br />
    <abbr title="Phone">P:</abbr>
    425.555.0100
</address>

<address>
    <strong>Support:</strong>   <a href="mailto:Support@example.com">Support@example.com</a><br />
    <strong>Marketing:</strong> <a href="mailto:Marketing@example.com">Marketing@example.com</a>
</address>

OnlineStore.Mvc.Web/Views/Home/Details.cshtml
@model OnlineStore.Core.Models.Product

@{
    ViewBag.Title = Model.Name + "Details";
}

<h2>@Html.DisplayFor(model => model.Name)</h2>

<div style="background-color:white">
    <div class="col-md-2">
        <img class="img-responsive" src="~/Content/ProductImages/@Model.Image" />
    </div>
    <div class="col-md-10">
        <dl class="dl-horizontal">
            <dt>
                @Html.DisplayNameFor(model => model.Name)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Name)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Description)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Description)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Price)
            </dt>

            <dd>
                $@Html.DisplayFor(model => model.Price)
            </dd>       
            

            <dt></dt>
            <dd>
                <a href="@Url.Action("AddToBusket","Busket",new { Id = Model.Id})" class="btn btn-default">Add To Busket</a>
            </dd>
            <dt></dt>
            <dd>
                @Html.ActionLink("Edit", "Edit", new { id = Model.Id }) |
                @Html.ActionLink("Back to List", "Index")
            </dd>

        </dl>
    </div>
</div>
<div class="col-md-12 clearfix">

</div>

OnlineStore.Mvc.Web/Views/Home/Index.cshtml
@model OnlineStore.Core.ViewModels.ProductListView
@{
    ViewBag.Title = "Home Page";
}

    <div class="bg-success" style="margin:10px">
        <img style="width:100%;height:450px;" src="~/Content/ProductImages/2c8204e52f9d637c7f7910c03e1e36fb-1024x631.jpeg" />
    </div>
    <div class="container body-content" style="background-color:white">
        <h1 align="center" style="color: darkslategrey;font-weight:bolder">PRODUCT</h1>
        <hr />
        <br />
        <div class="col-md-2">
            <h style="font-weight:bolder;font-size:14px;color:darkcyan">Filter By Category</h>
            <hr />
            <div class="list-group">
                @Html.ActionLink("All", "Index", null, new { @class = Request["Category"] == null ? "list-group-item active" : "list-group-item" })
                @foreach (var category in Model.ProductCategories)
                {
                    @Html.ActionLink(category.Category, "Index", new { Category = category.Category }, new { @class = Request["Category"] == category.Category ? "list-group-item active" : "list-group-item" })
                }
            </div>
        </div>
        <div class="col-md-10">
            @foreach (var item in Model.Products)
            {
                <div class="col-md-4" style="height:450px;padding:10px;margin:10px;border:solid thin;border-color:whitesmoke;">
                    <div class="col-md-12">
                        <img class="img" style="height:250px;width:200px" src="~/Content/ProductImages/@item.Image" />
                    </div>
                    <div class="col-md-12">
                        <strong>@Html.ActionLink(item.Name, "Details", new { id = item.Id })</strong>
                    </div>
                    <div class="col-md-12">
                        <p>@item.Description</p>
                    </div>
                    <div class="col-md-12">
                        <h4>@item.Price</h4>
                    </div>
                    <div class="col-md-12">
                        <a href="@Url.Action("AddToBusket","Busket",new { id = item.Id})" class="btn btn-default">Add To Busket</a>
                    </div>
                </div>
            }
        </div>
        <div class="col-md-12 clearfix" />
    </div>